MetaUpgradeData =
{
	BaseMetaUpgrade =
	{
		UsePromptOffsetX = 60,
		UsePromptOffsetY = 15,
		ResourceName = "LockKeys",
		UnlockCost = 10,
	},

	HealthMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		RequiredAccumulatedMetaPoints = 200,
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 6	--顽强抵抗
		CostTable = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },	--CostTable = { 40, 45, 50, 55, 60, 65, 70, 75, 80, 85 },
		ShortTotal = "HealthMetaUpgrade_ShortTotal",
		ChangeValue = 5,
		PropertyChanges =
		{
			{
				LuaProperty = "MaxHealth",
				ChangeValue = 5,
				ChangeType = "Add",
			},
		}
	},

	HealthEncounterEndRegenMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Skip = true,
		RequiredAccumulatedMetaPoints = 75,
		ResourceName = "LockKeys",
		UnlockCost = 3,
		CostTable = { 25, 75, 150, 500 },
		ShortTotal = "HealthEncounterEndRegenMetaUpgrade_ShortTotal",
		ChangeValue = 10,
	},

	DoorHealMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 0, 0, 0 },	--CostTable = { 10, 20, 40 },	--冥府活力
		ShortTotal = "DoorHealMetaUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	HealthDropMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Skip = true,
		RequiredAccumulatedMetaPoints = 200,
		CostTable = { 50, 100, 150, 200, 300 },
		ShortTotal = "HealthDropMetaUpgrade_ShortTotal",
		ChangeValue = 1.01,
		FormatAsPercent = true,
	},

	WeaponDamageMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Skip = true,
		Cost = 10,
		CostIncreaseInterval = 1,
		CostIncrease = 10,
		ShortTotal = "WeaponDamageMetaUpgrade_ShortTotal",
		PropertyChanges =
		{
			{
				WeaponNames = WeaponSets.HeroPhysicalWeapons,
				ProjectileProperty = "DamageLow",
				ChangeValue = 1.10,
				ChangeType = "MultiplyBase",
			},
			{
				WeaponNames = WeaponSets.HeroPhysicalWeapons,
				ProjectileProperty = "DamageHigh",
				ChangeValue = 1.10,
				ChangeType = "MultiplyBase",
			},
		},

	},

	DashAttackMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		ResourceName = "LockKeys",
		UnlockCost = 3,
		CostTable = { 10, 20, 30, 40, 50, 60, 70, 80, 90, 100 },
		Skip = true,
		ShortTotal = "DashAttackMetaUpgrade_ShortTotal",
		ReapplyOnWeaponSwitch = true,
		ChangeValue = 1.10,
		FormatAsPercent = true,
		PropertyChanges =
		{
			{
				WeaponName = "SwordWeaponDash",
				ProjectileProperty = "DamageAddition",
				ChangeValue = 1,
				ChangeType = "Add",
			},
			{
				WeaponName = "ShieldWeaponDash",
				ProjectileProperty = "DamageAddition",
				ChangeValue = 2,
				ChangeType = "Add",
			},
			{
				WeaponName = "SpearWeaponDash",
				ProjectileProperty = "DamageAddition",
				ChangeValue = 1.5,
				ChangeType = "Add",
			},
			{
				WeaponName = "BowWeaponDash",
				ProjectileProperty = "DamageAddition",
				ChangeValue = 3,
				ChangeType = "Add",
			},
		},
	},

	AmmoMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 3,	--地狱之魂
		Cost = 10,
		CostTable = { 0, 0 },	--CostTable = { 20, 80 },
		ShortTotal = "AmmoMetaUpgrade_ShortTotal",
		PropertyChanges =
		{
			{
				WeaponNames = WeaponSets.HeroNonPhysicalWeapons,
				WeaponProperty = "MaxAmmo",
				ChangeValue = 1,
				ChangeType = "Add",
			},
		},
	},

	StaminaMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 0 },	--CostTable = { 50 },	--大反射
		ShortTotal = "StaminaMetaUpgrade_ShortTotal",
		PropertyChanges =
		{
			{
				WeaponNames = WeaponSets.HeroRushWeapons,
				WeaponProperty = "ClipSize",
				ChangeValue = 1,
				ChangeType = "Add",
			},
		},
	},

	BackstabMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 0, 0, 0, 0, 0 },	--CostTable = { 10, 15, 20, 25, 30 },	--影子突袭
		ShortTotal = "BackstabMetaUpgrade_ShortTotal",
		ChangeValue = 1.1,
		FormatAsPercent = true,
		AddOutgoingDamageModifiers =
		{
			HitVulnerabilityMultiplier = 1.1,
		}
	},

	StoredAmmoVulnerabilityMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 3,	--沸腾之血
		CostTable = { 0, 0, 0, 0, 0 },	--CostTable = { 10, 30, 50, 70, 90 },
		Color = { 255, 255, 255, 255 },
		ShortTotal = "StoredAmmoVulnerabilityMetaUpgrade_ShortTotal",
		ChangeValue = 1.1,
		FormatAsPercent = true,
		AddOutgoingDamageModifiers =
		{
			ValidWeapons = WeaponSets.HeroPrimarySecondaryWeapons,
			StoredAmmoMultiplier = 1.1,
		}
	},

	VulnerabilityEffectBonusMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 12,	--特权状态
		CostTable = { 0, 0 },	--CostTable = { 50, 100 },
		Color = { 255, 255, 255, 255 },
		ShortTotal = "VulnerabilityEffectBonusMetaUpgrade_ShortTotal",
		ChangeValue = 1.25,
		FormatAsPercent = true,
		AddOutgoingDamageModifiers =
		{
			MinRequiredVulnerabilityEffects = 2,
			PerVulnerabilityEffectAboveMinMultiplier = 1.25,
		}
	},

	ExtraChanceMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 0, 0, 0 },	--CostTable = { 30, 500, 1000 },	--死亡蔑视
		Color = { 255, 255, 255, 255 },
		ShortTotal = "ExtraChanceMetaUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	RallyMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Skip = true,
		RequiredAccumulatedMetaPoints = 200,
		ResourceName = "LockKeys",
		UnlockCost = 6,
		CostTable = { 40, 60, 100, 200 },
		ShortTotal = "RallyMetaUpgrade_ShortTotal",
		ChangeValue = 1.15,
		FormatAsPercent = true,
	},

	MoneyMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		RequiredAccumulatedMetaPoints = 120,
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 6,	--财大气粗
		CostTable = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },	--CostTable = { 30, 35, 40, 45, 50, 55, 60, 65, 70, 75 },
		ShortTotal = "MoneyMetaUpgrade_ShortTotal",
		ChangeValue = 10,
	},

	RareBoonDropMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		RequiredAccumulatedMetaPoints = 500,
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 12,	--奥林匹斯的恩赐
		Cost = 0,	--Cost = 50,
		MaxInvestment = 50,
		ShortTotal = "RareBoonDropMetaUpgrade_ShortTotal",
		ChangeValue = 1.01,
	},

	EpicBoonDropMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		RequiredAccumulatedMetaPoints = 1000,
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 24,	--神之骄傲
		Cost = 0,	--Cost = 100,
		MaxInvestment = 25,
		ShortTotal = "EpicBoonDropMetaUpgrade_ShortTotal",
		ChangeValue = 1.01,
	},

	RerollMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		ResourceName = "LockKeys",
		UnlockCost = 0,	--UnlockCost = 36,	--天赐神威
		CostTable = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },	--CostTable = { 1000, 2000, 3000, 4000, 5000, 10000, 20000, 30000, 40000, 50000 },
		ShortTotal = "RerollMetaUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	LimitMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Skip = true,
		Cost = 1,
		CostIncreaseInterval = 1,
		CostIncrease = 1,
		ShortTotal = "LimitMetaUpgrade_ShortTotal",
		ChangeValue = 1.02,
	},

	SpeedMetaUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Skip = true,
		Cost = 50,
		CostIncreaseInterval = 1,
		CostIncrease = 50,
		ShortTotal = "SpeedMetaUpgrade_ShortTotal",
		PropertyChanges =
		{
			{
				UnitProperty = "Speed",
				ChangeValue = 100,
				ChangeType = "Add",
			},
		},
	},

	-- Shrine/Difficulty/Heat MetaUpgrades
	MetaPointCapShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1, 1, 1, 1, 1 },
		--CostTable = { 1, 1, 2, 2, 3, 3, 4, 4, 5, 5 },
		NoPointsHelpTextId = "MetaPointCapShrineUpgrade_NoPoints",
		ShortTotal = "MetaPointCapShrineUpgrade_ShortTotal",
		BaseValue = 3000,
		ChangeValue = -500,
	},

	HealingReductionShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1, 1, 1, 1 },
		ShortTotal = "HealingReductionShrineUpgrade_ShortTotal",
		ChangeValue = 1.25,
	},

	ReducedLootChoicesShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1, 2 },
		ShortTotal = "ReducedLootChoicesShrineUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	ShopPricesShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		Cost = 1,
		MaxInvestment = 2,
		ShortTotal = "ShopPricesShrineUpgrade_ShortTotal",
		ChangeValue = 1.5,
	},

	EnemyHealthShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		Cost = 1,
		MaxInvestment = 2,
		ShortTotal = "EnemyHealthShrineUpgrade_ShortTotal",
		ChangeValue = 1.15,
	},

	EnemyDamageShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		Cost = 1,
		MaxInvestment = 4,
		ShortTotal = "EnemyDamageShrineUpgrade_ShortTotal",
		ChangeValue = 1.25,
	},

	TrapDamageShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		Cost = 1,
		MaxInvestment = 2,
		ShortTotal = "EnemyDamageShrineUpgrade_ShortTotal",
		ChangeValue = 5,
		FormatAsPercent = true,
	},

	EnemySpeedShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		Cost = 1,
		MaxInvestment = 5,
		ShortTotal = "EnemySpeedShrineUpgrade_ShortTotal",
		ChangeValue = 1.1,
	},

	EnemyShieldShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1, 1 },
		ShortTotal = "EnemyShieldShrineUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	EnemyCountShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1, 1, 1 },
		ShortTotal = "EnemyCountShrineUpgrade_ShortTotal",
		ChangeValue = 1.20,
	},

	MinibossCountShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 2 },
		ShortTotal = "MinibossCountShrineUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	ForceSellShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1 },
		ShortTotal = "ForceSellShrineUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	BossDifficultyShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1, 2, 2 },
		ShortTotal = "BossDifficultyShrineUpgrade_ShortTotal",
		ChangeValue = 1,
		GameStateRequirements =
		{
			RequiredTextLines = { "Fury2FirstAppearance", "Fury3FirstAppearance" }
		},
	},

	HarpyDifficultyShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Skip = true,
		CostTable = { 1, 1 },
		ShortTotal = "HarpyDifficultyShrineUpgrade_ShortTotal",
		ChangeValue = 1,
		GameStateRequirements =
		{
			RequiredTextLines = { "Fury2FirstAppearance", "Fury3FirstAppearance" }
		},
	},
	HydraDifficultyShrineUpgrade =
	{
		Skip = true,
		InheritFrom = { "BaseMetaUpgrade", },
		CostTable = { 1 },
		ShortTotal = "HydraDifficultyShrineUpgrade_ShortTotal",
		ChangeValue = 1,
	},


	HardEncounterShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 2, 2, 2 },
		ShortTotal = "HardEncounterShrineUpgrade_ShortTotal",
		ChangeValue = 1,
	},

	BiomeSpeedShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 2, 3 },
		ShortTotal = "BiomeSpeedShrineUpgrade_ShortTotal",
		HelpTextTable =
		{
			[0] = "BiomeSpeedShrineUpgrade_0",
			[1] = "BiomeSpeedShrineUpgrade_1",
			[2] = "BiomeSpeedShrineUpgrade_2"
		},
		ChangeValue = 1,
	},

	NoInvulnerabilityShrineUpgrade =
	{
		InheritFrom = { "BaseMetaUpgrade", },
		Starting = true,
		CostTable = { 1 },
		ShortTotal = "NoInvulnerabilityShrineUpgrade_ShortTotal",
		ChangeValue = 1,
		GameStateRequirements =
		{
			RequiredTrueFlags = { "HardMode", },
		},
	}
}

MetaUpgradeOrder =
{
	"BackstabMetaUpgrade",
	"DoorHealMetaUpgrade",
	"ExtraChanceMetaUpgrade",
	"StaminaMetaUpgrade",
	"StoredAmmoVulnerabilityMetaUpgrade",
	"AmmoMetaUpgrade",
	"MoneyMetaUpgrade",
	"HealthMetaUpgrade",
	"VulnerabilityEffectBonusMetaUpgrade",
	"RareBoonDropMetaUpgrade",
	"EpicBoonDropMetaUpgrade",
	"RerollMetaUpgrade",
}

BiomeTimeLimits =
{
	ValidBiomes = { "Tartarus", "Asphodel", "Elysium", "Styx" },
	-- corresponds to BiomeList
	Penalty =
	{
		Damage = 5,
		Interval = 1,
	},
	Timers =
	{
		--{ 0, 480, 600, 720, 900 },
		--{ 0, 420, 540, 600, 720 },

		{ 0, 540, 540, 540, 540 },
		{ 0, 420, 420, 420, 420 },
	}
}

ShrineUpgradeOrder =
{
	"EnemyDamageShrineUpgrade",
	"HealingReductionShrineUpgrade",
	"ShopPricesShrineUpgrade",
	"EnemyCountShrineUpgrade",
	"BossDifficultyShrineUpgrade",

	"EnemyHealthShrineUpgrade",
	"MinibossCountShrineUpgrade",
	"ForceSellShrineUpgrade",
	"EnemySpeedShrineUpgrade",

	"TrapDamageShrineUpgrade",
	"MetaPointCapShrineUpgrade",
	"EnemyShieldShrineUpgrade",
	"ReducedLootChoicesShrineUpgrade",
	"BiomeSpeedShrineUpgrade",
	"NoInvulnerabilityShrineUpgrade",
}

ShrineClearData =
{
	ClearThreshold = 1,
	BossRoomNames = { "A_Boss", "B_Boss01", "C_Boss01", "D_Boss01" },
}